package shinh;

import robocode.*;

import java.util.*;
import java.awt.Color;
import java.io.*;

public class You extends AdvancedRobot {
	private final double PI = Math.PI;
	private final double PI2 = PI * 2;
	private final double PI_2 = PI / 2;
	private final double PI_4 = PI / 4;
	private final double PI3_2 = PI * 3 / 2;

	private final int KEY_UP = 1;
	private final int KEY_DOWN = 2;
	private final int KEY_RIGHT = 4;
	private final int KEY_LEFT = 8;

	private double getRelativeRadian(double rad) {
		while (rad <= -PI) rad += PI2;
		while (rad > PI) rad -= PI2;
		return rad;
	}

	private void goRadian(double rad) {
		double trans = getRelativeRadian(rad - getHeadingRadians());
		if (trans >= PI_2) {
			setBack(100);
			setTurnRightRadians(trans-PI);
		}
		else if (trans >= -PI_2) {
			setAhead(100);
			setTurnRightRadians(trans);
		}
		else {
			setBack(100);
			setTurnRightRadians(PI+trans);
		}
	}

	private void runInput() {
		try {
			File inputFile = getDataFile("input");
			if (!inputFile.canRead()) return;

			FileInputStream input = new FileInputStream(inputFile);
			int in = input.read();
			int aim = input.read();
			input.close();

			double aimRad = (PI * aim) / 128.0;
			setTurnGunRightRadians(getRelativeRadian(
									   aimRad-getGunHeadingRadians()));

			if (in == -1) return;

			int axis = in & 15;
			int fire = in & 16;

			double goRad;

			if (fire != 0) {
				setFire(3);
			}

			switch (axis) {
			case KEY_UP:
				goRad = 0;
				break;
			case KEY_DOWN:
				goRad = PI;
				break;
			case KEY_RIGHT:
				goRad = PI_2;
				break;
			case KEY_LEFT:
				goRad = PI3_2;
				break;
			case (KEY_UP|KEY_RIGHT):
				goRad = PI_4;
				break;
			case (KEY_DOWN|KEY_RIGHT):
				goRad = PI_4 * 3;
				break;
			case (KEY_UP|KEY_LEFT):
				goRad = PI_4 * 7;
				break;
			case (KEY_DOWN|KEY_LEFT):
				goRad = PI_4 * 5;
				break;
			default:
				setAhead(0);
				return;
			}
			goRadian(goRad);
		}
		catch (IOException ie) {
			out.println(ie.getStackTrace().toString());
		}
	}

	public void run() {
		setColors(new Color(255, 255, 255),
				  new Color(255, 255, 255),
				  new Color(255, 255, 255));

		setAdjustGunForRobotTurn(true);

		while (true) {
			runInput();
			execute();
		}
	}
}
